export async function addMarks(text, words) {
    if (words.length === 0)
        return text;
    const replaceAll = (str, find, replace) => str.replace(new RegExp(find.replace(/([.*+?^=!:${}()|\[\]\/\\])/g, "\\$1"), 'g'), replace);
    const searchWords = words.split(" ").filter(i => i.trim().length > 0);
    const markedText = text.replace(new RegExp(searchWords.join("|"), "gi"), matched => `<mark>${matched}</mark>`);
    // https://stackoverflow.com/a/7671978/9238321
    // remove <mark></mark> from any html attributes
    return markedText.replace(new RegExp(/[\w:\-]+ ?= ?("[^"]+"|'[^']+'|\w+)/, 'g'), matched => replaceAll(replaceAll(matched, '</mark>', ''), '<mark>', ''));
}
