import { Component, h, Host, Prop, State, Watch } from '@stencil/core';
import { addMarks } from '../../add-marks.worker';
export class Markster {
    constructor() {
        this.markedText = "";
    }
    componentWillLoad() {
        this.applyMarks();
    }
    async applyMarks() {
        this.markedText = await addMarks(this.text, this.searchWords);
    }
    render() {
        return h(Host, null,
            h("span", { innerHTML: this.markedText }));
    }
    static get is() { return "mark-ster"; }
    static get properties() { return {
        "text": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "text",
            "reflect": false
        },
        "searchWords": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "search-words",
            "reflect": false
        }
    }; }
    static get states() { return {
        "markedText": {}
    }; }
    static get watchers() { return [{
            "propName": "text",
            "methodName": "applyMarks"
        }, {
            "propName": "searchWords",
            "methodName": "applyMarks"
        }]; }
}
