var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { r as registerInstance, h, H as Host } from './index-2977ba55.js';
var pendingIds = 0;
var callbackIds = 0;
var pending = new Map();
var callbacks = new Map();
var createWorker = function (workerPath, workerName, workerMsgId) {
    var worker = new Worker(workerPath, { name: workerName });
    worker.addEventListener('message', function (_a) {
        var data = _a.data;
        if (data) {
            var workerMsg = data[0];
            var id = data[1];
            var value = data[2];
            if (workerMsg === workerMsgId) {
                var err = data[3];
                var _b = pending.get(id), resolve = _b[0], reject = _b[1], callbackIds_1 = _b[2];
                pending.delete(id);
                if (err) {
                    reject(err);
                }
                else {
                    if (callbackIds_1) {
                        callbackIds_1.forEach(function (id) { return callbacks.delete(id); });
                    }
                    resolve(value);
                }
            }
            else if (workerMsg === workerMsgId + '.cb') {
                try {
                    callbacks.get(id).apply(void 0, value);
                }
                catch (e) {
                    console.error(e);
                }
            }
        }
    });
    return worker;
};
var createWorkerProxy = function (worker, workerMsgId, exportedMethod) { return (function () {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    return new Promise(function (resolve, reject) {
        var pendingId = pendingIds++;
        var i = 0;
        var argLen = args.length;
        var mainData = [resolve, reject];
        pending.set(pendingId, mainData);
        for (; i < argLen; i++) {
            if (typeof args[i] === 'function') {
                var callbackId = callbackIds++;
                callbacks.set(callbackId, args[i]);
                args[i] = [workerMsgId + '.cb', callbackId];
                (mainData[2] = mainData[2] || []).push(callbackId);
            }
        }
        var postMessage = function (w) { return (w.postMessage([workerMsgId, pendingId, exportedMethod, args], args.filter(function (a) { return a instanceof ArrayBuffer; }))); };
        if (worker.then) {
            worker.then(postMessage);
        }
        else {
            postMessage(worker);
        }
    });
}); };
var workerPromise = import('./add-marks.worker-f7b896a8.js').then(function (m) { return m.worker; });
var addMarks = /*@__PURE__*/ createWorkerProxy(workerPromise, 'stencil.add-marks.worker', 'addMarks');
var Markster = /** @class */ (function () {
    function class_1(hostRef) {
        registerInstance(this, hostRef);
        this.markedText = "";
    }
    class_1.prototype.componentWillLoad = function () {
        this.applyMarks();
    };
    class_1.prototype.applyMarks = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this;
                        return [4 /*yield*/, addMarks(this.text, this.searchWords)];
                    case 1:
                        _a.markedText = _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    class_1.prototype.render = function () {
        return h(Host, null, h("span", { innerHTML: this.markedText }));
    };
    Object.defineProperty(class_1, "watchers", {
        get: function () {
            return {
                "text": ["applyMarks"],
                "searchWords": ["applyMarks"]
            };
        },
        enumerable: false,
        configurable: true
    });
    return class_1;
}());
export { Markster as M, createWorker as c };
